<template>
    <div class="login-box">
        <div class="login-logo center">
            <img src="https://acis.org.co/portal/sites/default/files/Logotipo-MIleniumgroup-03.png" style="margin: 0 auto;">
        </div>
        <!-- /.login-logo -->
        <div class="card">
            <div class="card-body login-card-body">
                <p class="login-box-msg">Restaura tu contraseña</p>
                <form method="post">
                    <div class="input-group mb-3">
                        <input @keyup.enter="resetPassword" v-model="fillLogin.cEmail" type="email" class="form-control" placeholder="Email">
                        <div class="input-group-append">
                            <div class="input-group-text">
                                <span class="fas fa-envelope"></span>
                            </div>
                        </div>
                    </div>
                </form>

                <div class="row">
                    <div class="col-12">
                        <span v-if="error">
                            <div v-for="(e, index) in mensajeError" :key="index" v-text="e" class="callout callout-danger"></div>
                        </span>
                    </div>
                </div>
                <div class="social-auth-links text-center mb-3">
                    <button class="btn btn-flat btn-primary" @click.prevent="resetPassword" v-loading.fullscreen.lock="fullscreenLoading">
                        Enviar
                    </button>              
                </div>
                
            </div>
            <!-- /.login-card-body -->
        </div>
    </div>
</template>

<script>
    export default {
        data() {
            return {
                fillLogin: {
                    cEmail: '',
                },
                fullscreenLoading: false,
                error: 0,
                mensajeError: []
            }
        },
        methods: {
            resetPassword() {
                if(this.validForm()) {
                    return;
                }

                this.fullscreenLoading = true;
                axios.post('/resetPassword', {
                    'cEmail' : this.fillLogin.cEmail,                    
                }).then(response=> {
                    // console.log(response);
                    if(response.data.code == 401) {
                        this.restoreFailed(response.data.message);
                    }
                    if(response.data.code == 200) {
                        this.restoreSuccess();
                    }              
                });
            },
            validForm() {
                this.error = 0;
                this.mensajeError = [];

                if(!this.fillLogin.cEmail) {
                    this.mensajeError.push('El correo electronico es un campo obligatorio');
                }

                if(this.mensajeError.length) {
                    this.error = 1;
                }

                return this.error;
            },
            restoreFailed(message) {
                this.fullscreenLoading = false;
                this.error = 0;
                this.mensajeError = []; 

                this.mensajeError.push((message) ? message : 'Hubo un error en la actualización de la contraseña, contacte con el administrador.');

                this.fillLogin.cEmail = '';

                if(this.mensajeError.length) {
                    this.error = 1;
                }

                return this.error;
            }, 
            restoreSuccess() {
                /*
                */
                this.$swal({
                    icon: 'success',
                    title: 'Hemos enviado un correo electronico con los pasos para restablecer la contraseña',
                    confirmButtonText: 'Ok'
                }).then((result) => {
                    if (result.isConfirmed) {
                        window.location.href = '/login';
                    }
                });
                this.fullscreenLoading = false;
            }, 
        }
    }
</script>

<style>

</style>